Program DVM_Datalogger_2;
{$M 40000,0,0}

Uses CRT, Dos;
Const  BufMax = 32767;
var BA : Integer;
    Buffer: Array [0..32767] of Byte;
    N: Word;
    T: Real;
    Ticker_Counter : Real;
    SampleZeit: Real;
    f : File of Word;
    Parameter: String;
    Offset,Segment: Word;
    OldVector : Pointer;

procedure Oeffnen;
 var  Wert : Byte;
 begin
    Port[BA+3]:=$80; { }
    Port[BA+0]:=$60; { 1200 Baud }
    Port[BA+1]:=$00;
    Port[BA+3]:=$06; { 7-Bit, n-Parity, 2 Stopbits }
    Port[BA+4]:=$09; { DTR = 1, RTS = 0, out2 fr interrupt }
    wert := Port [BA];
    wert := Port [BA];
    Port[BA+1]:=$01;   { Freigabe: Interrupt fr Empfang }
 end;

procedure Sende (Zeichen :Byte);
begin
  while (Port[BA+5] And 32) = 0 do;  { Sende-Halteregister leer? }
  Port[BA]:=Zeichen;
end;

{$F+}
procedure Int_Routine;Interrupt;
{$F-}
var Wert: Byte;
begin
     wert := port [BA];
     if chr(Wert) in ['0'..'9','.',#13] then begin
       Buffer [N] := Wert;            { Zahlenwerte ohne Einheiten }
       Inc (N);
     end;
     Port[$20]:=$20;                  { OCW2, end of Interrupt }
end;

{$F+}
procedure TimerInterrupt
   (flags,cs,ax,bx,cx,dx,si,di,ds,es,bp :Word);
   Interrupt;
{$F-}
begin
  if ((Ticker_Counter * 0.0549269) >= (T * SampleZeit)) then begin
    Sende (ord('D'));
    T := T+1;
  end;
  Ticker_Counter:= Ticker_Counter+1;
  Inline ($9C/$3E/$FF/$1E/OldVector);
  if n  > 32767 then SetIntVec ($1C,OldVector);    {Interrupt abschalten}
end;

procedure Init_IRQ4;
begin
  inline ($FA);
  SetIntVec($0C,@INT_ROUTINE);
  inline ($FB);
  Port[$21]:=Port[$21] AND $EF;      { OCW1: IRQ4 freigeben }
end;

procedure Init_IRQ3;
begin
  inline ($FA);
  SetIntVec($0B,@INT_ROUTINE);
  inline ($FB);
  Port[$21]:=Port[$21] AND $F7;      { OCW1: IRQ3 freigeben }
end;

begin
  for N := 0 to 32767 do Buffer[N] := 0;
  write ('Abtastperiode in Sekunden ');
  readln (SampleZeit);
  N := 0; T := 0; Ticker_Counter := 0;
  BA:=$02F8;          {COM2}
  Oeffnen;
  Init_IRQ3;          {fr COM2}
  writeln ('Data-Logger aktiv');
  assign (f,'DATA.ADR');
  rewrite (f);
  Segment := Seg(Buffer);
  Offset := Ofs(Buffer);
  write (f, Segment);
  write (f, Offset);
  close (f);
  writeln (Seg(Buffer),' ',Ofs(Buffer));
  GetIntVec ($1C,OldVector);
  SetIntVec ($1C,@TimerInterrupt);
  Keep (0);
end.

